<template>
  <nivel-cumplimiento
    :loadingTitle="loadingTitle"
    :loadingContent="loadingContent"
    :titleNotFound="titleNotFound"
    :contentNotFound="contentNotFound"
    :data="data"
  />
</template>
<script>
import NivelCumplimiento from "@/views/secure/sistema-informacion/dashboards/v2/disciplinas/components/graficas/NivelCumplimiento.vue";
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-No2NivelCumplimientoImpl",
  props: ["filters"],
  components: {
    NivelCumplimiento,
  },
  data() {
    return {
      loadingTitle: true,
      loadingContent: true,
      titleNotFound: false,
      contentNotFound: false,
      semaforo: null,
      semaforoUtils: null,
      data: {
        descripcion: null,
        total: null,
        leyeda: "Puntos de venta evaluados y porcentajes aprobados",
        values: [],
      },
    };
  },
  watch: {
    filters(val) {
      this.getData();
    },
    "semaforo.idSemaforo"(val) {
      this.getData();
    },
    semaforoUtils(val) {
      this.setBarColor();
    },
  },
  methods: {
    getSemaforoRangos(semaforo) {
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" +
          semaforo.idSemaforo +
          "/rangos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            semaforo.rangos = data.resultado.rangos;
            this.semaforoUtils = {
              getColor: this.getColorByValue,
            };
          }
        })
        .catch((error) => {});
    },
    getSemaforo(semaforoLocal) {
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" + semaforoLocal.idSemaforo
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.semaforo = {
              ...semaforoLocal,
              ...data.resultado,
            };
            this.getSemaforoRangos(this.semaforo);
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.semaforo = {};
          } else {
            console.log(error);
          }
        });
    },
    getColorByValue(value) {
      let rango = this.semaforo.rangos.filter((item)=>item.idRango == value);
      if (rango.length > 0) {
        return rango[0].color;
      } else {
        return null;
      }
    },
    getSemaforoDefectoGrafica(grafica) {
      axios(
        "/sistema-informacion/tablero/graficas/v1/" +
          grafica.idGrafica +
          "/semaforos/regla"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.semaforo = data.resultado;
            this.getSemaforo(this.semaforo);
          }
        })
        .catch((error) => {});
    },
    getGrafica() {
      axios(
        "/sistema-informacion/tablero/graficas/v1/clave/generica-nivel-cumplimiento"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data = Object.assign(this.data, data.resultado);
            this.getSemaforoDefectoGrafica(this.data);
          }
        })
        .catch((error) => {
          this.titleNotFound = true;
          console.log(error);
        })
        .finally(() => {
          this.loadingTitle = false;
        });
    },
    getData() {
      this.loadingContent = true;
      this.contentNotFound = false;
      if (this.semaforo && this.filters && this.filters.request) {
        let body = {
          ...this.filters.request,
          idSemaforo: this.semaforo.idSemaforo,
        };
        axios
          .post(
            "/sistema-informacion/tablero/reportes/v1/disciplinas/" +
              this.filters.path.idDisciplina +
              "/generico/niveles-cumplimiento/busquedas",
            body
          )
          .then((response) => {
            let data = response.data;
            if (data) {
              let nivelCumplimientoTotal =
                data.resultado.nivelCumplimientoTotal;
              this.data.values = [];
              this.data.total = nivelCumplimientoTotal.puntosVenta;
              nivelCumplimientoTotal.nivelesCumplimiento.forEach((element) => {
                this.data.values.push({
                  label: null,
                  value: element.puntosVenta,
                  idRango : element.idRango,
                  color: "black",
                  porcentaje: element.porcentaje,
                });
              });
              this.setBarColor();
            }
          })
          .catch((error) => {
            this.contentNotFound = true;
            console.log(error);
          })
          .finally(() => {
            this.loadingContent = false;
          });
      }
    },
    setBarColor() {
      if (this.semaforoUtils && this.data && this.data.values) {
        this.data.values = this.data.values.map((element) => {
          let color = this.semaforoUtils.getColor(element.idRango);
          element.color = color;
          return element;
        });
      }
    },
  },
  created() {
    this.getGrafica();
  },
};
</script>
